/**********************************************************************
// @@@ START COPYRIGHT @@@
//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
//
//   http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//
// @@@ END COPYRIGHT @@@
**********************************************************************/
 /* 0x8140 */ 0x3000 , /* IDEOGRAPHIC SPACE */
 /* 0x8141 */ 0x3001 , /* IDEOGRAPHIC COMMA */
 /* 0x8142 */ 0x3002 , /* IDEOGRAPHIC FULL STOP */
 /* 0x8143 */ 0xFF0C , /* FULLWIDTH COMMA */
 /* 0x8144 */ 0xFF0E , /* FULLWIDTH FULL STOP */
 /* 0x8145 */ 0x30FB , /* KATAKANA MIDDLE DOT */
 /* 0x8146 */ 0xFF1A , /* FULLWIDTH COLON */
 /* 0x8147 */ 0xFF1B , /* FULLWIDTH SEMICOLON */
 /* 0x8148 */ 0xFF1F , /* FULLWIDTH QUESTION MARK */
 /* 0x8149 */ 0xFF01 , /* FULLWIDTH EXCLAMATION MARK */
 /* 0x814A */ 0x309B , /* KATAKANA-HIRAGANA VOICED SOUND MARK */
 /* 0x814B */ 0x309C , /* KATAKANA-HIRAGANA SEMI-VOICED SOUND MARK */
 /* 0x814C */ 0x00B4 , /* ACUTE ACCENT */
 /* 0x814D */ 0xFF40 , /* FULLWIDTH GRAVE ACCENT */
 /* 0x814E */ 0x00A8 , /* DIAERESIS */
 /* 0x814F */ 0xFF3E , /* FULLWIDTH CIRCUMFLEX ACCENT */
 /* 0x8150 */ 0xFFE3 , /* FULLWIDTH MACRON */
 /* 0x8151 */ 0xFF3F , /* FULLWIDTH LOW LINE */
 /* 0x8152 */ 0x30FD , /* KATAKANA ITERATION MARK */
 /* 0x8153 */ 0x30FE , /* KATAKANA VOICED ITERATION MARK */
 /* 0x8154 */ 0x309D , /* HIRAGANA ITERATION MARK */
 /* 0x8155 */ 0x309E , /* HIRAGANA VOICED ITERATION MARK */
 /* 0x8156 */ 0x3003 , /* DITTO MARK */
 /* 0x8157 */ 0x4EDD , /* <CJK> */
 /* 0x8158 */ 0x3005 , /* IDEOGRAPHIC ITERATION MARK */
 /* 0x8159 */ 0x3006 , /* IDEOGRAPHIC CLOSING MARK */
 /* 0x815A */ 0x3007 , /* IDEOGRAPHIC NUMBER ZERO */
 /* 0x815B */ 0x30FC , /* KATAKANA-HIRAGANA PROLONGED SOUND MARK */
 /* 0x815C */ 0x2015 , /* HORIZONTAL BAR */
 /* 0x815D */ 0x2010 , /* HYPHEN */
 /* 0x815E */ 0xFF0F , /* FULLWIDTH SOLIDUS */
 /* 0x815F */ 0xFF3C , /* REVERSE SOLIDUS */
 /* 0x8160 */ 0xFF5E , /* WAVE DASH */
 /* 0x8161 */ 0x2225 , /* DOUBLE VERTICAL LINE */
 /* 0x8162 */ 0xFF5C , /* FULLWIDTH VERTICAL LINE */
 /* 0x8163 */ 0x2026 , /* HORIZONTAL ELLIPSIS */
 /* 0x8164 */ 0x2025 , /* TWO DOT LEADER */
 /* 0x8165 */ 0x2018 , /* LEFT SINGLE QUOTATION MARK */
 /* 0x8166 */ 0x2019 , /* RIGHT SINGLE QUOTATION MARK */
 /* 0x8167 */ 0x201C , /* LEFT DOUBLE QUOTATION MARK */
 /* 0x8168 */ 0x201D , /* RIGHT DOUBLE QUOTATION MARK */
 /* 0x8169 */ 0xFF08 , /* FULLWIDTH LEFT PARENTHESIS */
 /* 0x816A */ 0xFF09 , /* FULLWIDTH RIGHT PARENTHESIS */
 /* 0x816B */ 0x3014 , /* LEFT TORTOISE SHELL BRACKET */
 /* 0x816C */ 0x3015 , /* RIGHT TORTOISE SHELL BRACKET */
 /* 0x816D */ 0xFF3B , /* FULLWIDTH LEFT SQUARE BRACKET */
 /* 0x816E */ 0xFF3D , /* FULLWIDTH RIGHT SQUARE BRACKET */
 /* 0x816F */ 0xFF5B , /* FULLWIDTH LEFT CURLY BRACKET */
 /* 0x8170 */ 0xFF5D , /* FULLWIDTH RIGHT CURLY BRACKET */
 /* 0x8171 */ 0x3008 , /* LEFT ANGLE BRACKET */
 /* 0x8172 */ 0x3009 , /* RIGHT ANGLE BRACKET */
 /* 0x8173 */ 0x300A , /* LEFT DOUBLE ANGLE BRACKET */
 /* 0x8174 */ 0x300B , /* RIGHT DOUBLE ANGLE BRACKET */
 /* 0x8175 */ 0x300C , /* LEFT CORNER BRACKET */
 /* 0x8176 */ 0x300D , /* RIGHT CORNER BRACKET */
 /* 0x8177 */ 0x300E , /* LEFT WHITE CORNER BRACKET */
 /* 0x8178 */ 0x300F , /* RIGHT WHITE CORNER BRACKET */
 /* 0x8179 */ 0x3010 , /* LEFT BLACK LENTICULAR BRACKET */
 /* 0x817A */ 0x3011 , /* RIGHT BLACK LENTICULAR BRACKET */
 /* 0x817B */ 0xFF0B , /* FULLWIDTH PLUS SIGN */
 /* 0x817C */ 0xFF0D , /* MINUS SIGN */
 /* 0x817D */ 0x00B1 , /* PLUS-MINUS SIGN */
 /* 0x817E */ 0x00D7 , /* MULTIPLICATION SIGN */
 /* 0x8180 */ 0x00F7 , /* DIVISION SIGN */
 /* 0x8181 */ 0xFF1D , /* FULLWIDTH EQUALS SIGN */
 /* 0x8182 */ 0x2260 , /* NOT EQUAL TO */
 /* 0x8183 */ 0xFF1C , /* FULLWIDTH LESS-THAN SIGN */
 /* 0x8184 */ 0xFF1E , /* FULLWIDTH GREATER-THAN SIGN */
 /* 0x8185 */ 0x2266 , /* LESS-THAN OVER EQUAL TO */
 /* 0x8186 */ 0x2267 , /* GREATER-THAN OVER EQUAL TO */
 /* 0x8187 */ 0x221E , /* INFINITY */
 /* 0x8188 */ 0x2234 , /* THEREFORE */
 /* 0x8189 */ 0x2642 , /* MALE SIGN */
 /* 0x818A */ 0x2640 , /* FEMALE SIGN */
 /* 0x818B */ 0x00B0 , /* DEGREE SIGN */
 /* 0x818C */ 0x2032 , /* PRIME */
 /* 0x818D */ 0x2033 , /* DOUBLE PRIME */
 /* 0x818E */ 0x2103 , /* DEGREE CELSIUS */
 /* 0x818F */ 0xFFE5 , /* FULLWIDTH YEN SIGN */
 /* 0x8190 */ 0xFF04 , /* FULLWIDTH DOLLAR SIGN */
 /* 0x8191 */ 0xFFE0 , /* CENT SIGN */
 /* 0x8192 */ 0xFFE1 , /* POUND SIGN */
 /* 0x8193 */ 0xFF05 , /* FULLWIDTH PERCENT SIGN */
 /* 0x8194 */ 0xFF03 , /* FULLWIDTH NUMBER SIGN */
 /* 0x8195 */ 0xFF06 , /* FULLWIDTH AMPERSAND */
 /* 0x8196 */ 0xFF0A , /* FULLWIDTH ASTERISK */
 /* 0x8197 */ 0xFF20 , /* FULLWIDTH COMMERCIAL AT */
 /* 0x8198 */ 0x00A7 , /* SECTION SIGN */
 /* 0x8199 */ 0x2606 , /* WHITE STAR */
 /* 0x819A */ 0x2605 , /* BLACK STAR */
 /* 0x819B */ 0x25CB , /* WHITE CIRCLE */
 /* 0x819C */ 0x25CF , /* BLACK CIRCLE */
 /* 0x819D */ 0x25CE , /* BULLSEYE */
 /* 0x819E */ 0x25C7 , /* WHITE DIAMOND */
 /* 0x819F */ 0x25C6 , /* BLACK DIAMOND */
 /* 0x81A0 */ 0x25A1 , /* WHITE SQUARE */
 /* 0x81A1 */ 0x25A0 , /* BLACK SQUARE */
 /* 0x81A2 */ 0x25B3 , /* WHITE UP-POINTING TRIANGLE */
 /* 0x81A3 */ 0x25B2 , /* BLACK UP-POINTING TRIANGLE */
 /* 0x81A4 */ 0x25BD , /* WHITE DOWN-POINTING TRIANGLE */
 /* 0x81A5 */ 0x25BC , /* BLACK DOWN-POINTING TRIANGLE */
 /* 0x81A6 */ 0x203B , /* REFERENCE MARK */
 /* 0x81A7 */ 0x3012 , /* POSTAL MARK */
 /* 0x81A8 */ 0x2192 , /* RIGHTWARDS ARROW */
 /* 0x81A9 */ 0x2190 , /* LEFTWARDS ARROW */
 /* 0x81AA */ 0x2191 , /* UPWARDS ARROW */
 /* 0x81AB */ 0x2193 , /* DOWNWARDS ARROW */
 /* 0x81AC */ 0x3013 , /* GETA MARK */
 /* 0x81AD */ 0xFFFF ,
 /* 0x81AE */ 0xFFFF ,
 /* 0x81AF */ 0xFFFF ,
 /* 0x81B0 */ 0xFFFF ,
 /* 0x81B1 */ 0xFFFF ,
 /* 0x81B2 */ 0xFFFF ,
 /* 0x81B3 */ 0xFFFF ,
 /* 0x81B4 */ 0xFFFF ,
 /* 0x81B5 */ 0xFFFF ,
 /* 0x81B6 */ 0xFFFF ,
 /* 0x81B7 */ 0xFFFF ,
 /* 0x81B8 */ 0x2208 , /* ELEMENT OF */
 /* 0x81B9 */ 0x220B , /* CONTAINS AS MEMBER */
 /* 0x81BA */ 0x2286 , /* SUBSET OF OR EQUAL TO */
 /* 0x81BB */ 0x2287 , /* SUPERSET OF OR EQUAL TO */
 /* 0x81BC */ 0x2282 , /* SUBSET OF */
 /* 0x81BD */ 0x2283 , /* SUPERSET OF */
 /* 0x81BE */ 0x222A , /* UNION */
 /* 0x81BF */ 0x2229 , /* INTERSECTION */
 /* 0x81C0 */ 0xFFFF ,
 /* 0x81C1 */ 0xFFFF ,
 /* 0x81C2 */ 0xFFFF ,
 /* 0x81C3 */ 0xFFFF ,
 /* 0x81C4 */ 0xFFFF ,
 /* 0x81C5 */ 0xFFFF ,
 /* 0x81C6 */ 0xFFFF ,
 /* 0x81C7 */ 0xFFFF ,
 /* 0x81C8 */ 0x2227 , /* LOGICAL AND */
 /* 0x81C9 */ 0x2228 , /* LOGICAL OR */
 /* 0x81CA */ 0xFFE2 , /* NOT SIGN */
 /* 0x81CB */ 0x21D2 , /* RIGHTWARDS DOUBLE ARROW */
 /* 0x81CC */ 0x21D4 , /* LEFT RIGHT DOUBLE ARROW */
 /* 0x81CD */ 0x2200 , /* FOR ALL */
 /* 0x81CE */ 0x2203 , /* THERE EXISTS */
 /* 0x81CF */ 0xFFFF ,
 /* 0x81D0 */ 0xFFFF ,
 /* 0x81D1 */ 0xFFFF ,
 /* 0x81D2 */ 0xFFFF ,
 /* 0x81D3 */ 0xFFFF ,
 /* 0x81D4 */ 0xFFFF ,
 /* 0x81D5 */ 0xFFFF ,
 /* 0x81D6 */ 0xFFFF ,
 /* 0x81D7 */ 0xFFFF ,
 /* 0x81D8 */ 0xFFFF ,
 /* 0x81D9 */ 0xFFFF ,
 /* 0x81DA */ 0x2220 , /* ANGLE */
 /* 0x81DB */ 0x22A5 , /* UP TACK */
 /* 0x81DC */ 0x2312 , /* ARC */
 /* 0x81DD */ 0x2202 , /* PARTIAL DIFFERENTIAL */
 /* 0x81DE */ 0x2207 , /* NABLA */
 /* 0x81DF */ 0x2261 , /* IDENTICAL TO */
 /* 0x81E0 */ 0x2252 , /* APPROXIMATELY EQUAL TO OR THE IMAGE OF */
 /* 0x81E1 */ 0x226A , /* MUCH LESS-THAN */
 /* 0x81E2 */ 0x226B , /* MUCH GREATER-THAN */
 /* 0x81E3 */ 0x221A , /* SQUARE ROOT */
 /* 0x81E4 */ 0x223D , /* REVERSED TILDE */
 /* 0x81E5 */ 0x221D , /* PROPORTIONAL TO */
 /* 0x81E6 */ 0x2235 , /* BECAUSE */
 /* 0x81E7 */ 0x222B , /* INTEGRAL */
 /* 0x81E8 */ 0x222C , /* DOUBLE INTEGRAL */
 /* 0x81E9 */ 0xFFFF ,
 /* 0x81EA */ 0xFFFF ,
 /* 0x81EB */ 0xFFFF ,
 /* 0x81EC */ 0xFFFF ,
 /* 0x81ED */ 0xFFFF ,
 /* 0x81EE */ 0xFFFF ,
 /* 0x81EF */ 0xFFFF ,
 /* 0x81F0 */ 0x212B , /* ANGSTROM SIGN */
 /* 0x81F1 */ 0x2030 , /* PER MILLE SIGN */
 /* 0x81F2 */ 0x266F , /* MUSIC SHARP SIGN */
 /* 0x81F3 */ 0x266D , /* MUSIC FLAT SIGN */
 /* 0x81F4 */ 0x266A , /* EIGHTH NOTE */
 /* 0x81F5 */ 0x2020 , /* DAGGER */
 /* 0x81F6 */ 0x2021 , /* DOUBLE DAGGER */
 /* 0x81F7 */ 0x00B6 , /* PILCROW SIGN */
 /* 0x81F8 */ 0xFFFF ,
 /* 0x81F9 */ 0xFFFF ,
 /* 0x81FA */ 0xFFFF ,
 /* 0x81FB */ 0xFFFF ,
 /* 0x81FC */ 0x25EF , /* LARGE CIRCLE */
 /* 0x8240 */ 0xFFFF ,
 /* 0x8241 */ 0xFFFF ,
 /* 0x8242 */ 0xFFFF ,
 /* 0x8243 */ 0xFFFF ,
 /* 0x8244 */ 0xFFFF ,
 /* 0x8245 */ 0xFFFF ,
 /* 0x8246 */ 0xFFFF ,
 /* 0x8247 */ 0xFFFF ,
 /* 0x8248 */ 0xFFFF ,
 /* 0x8249 */ 0xFFFF ,
 /* 0x824A */ 0xFFFF ,
 /* 0x824B */ 0xFFFF ,
 /* 0x824C */ 0xFFFF ,
 /* 0x824D */ 0xFFFF ,
 /* 0x824E */ 0xFFFF ,
 /* 0x824F */ 0xFF10 , /* FULLWIDTH DIGIT ZERO */
 /* 0x8250 */ 0xFF11 , /* FULLWIDTH DIGIT ONE */
 /* 0x8251 */ 0xFF12 , /* FULLWIDTH DIGIT TWO */
 /* 0x8252 */ 0xFF13 , /* FULLWIDTH DIGIT THREE */
 /* 0x8253 */ 0xFF14 , /* FULLWIDTH DIGIT FOUR */
 /* 0x8254 */ 0xFF15 , /* FULLWIDTH DIGIT FIVE */
 /* 0x8255 */ 0xFF16 , /* FULLWIDTH DIGIT SIX */
 /* 0x8256 */ 0xFF17 , /* FULLWIDTH DIGIT SEVEN */
 /* 0x8257 */ 0xFF18 , /* FULLWIDTH DIGIT EIGHT */
 /* 0x8258 */ 0xFF19 , /* FULLWIDTH DIGIT NINE */
 /* 0x8259 */ 0xFFFF ,
 /* 0x825A */ 0xFFFF ,
 /* 0x825B */ 0xFFFF ,
 /* 0x825C */ 0xFFFF ,
 /* 0x825D */ 0xFFFF ,
 /* 0x825E */ 0xFFFF ,
 /* 0x825F */ 0xFFFF ,
 /* 0x8260 */ 0xFF21 , /* FULLWIDTH LATIN CAPITAL LETTER A */
 /* 0x8261 */ 0xFF22 , /* FULLWIDTH LATIN CAPITAL LETTER B */
 /* 0x8262 */ 0xFF23 , /* FULLWIDTH LATIN CAPITAL LETTER C */
 /* 0x8263 */ 0xFF24 , /* FULLWIDTH LATIN CAPITAL LETTER D */
 /* 0x8264 */ 0xFF25 , /* FULLWIDTH LATIN CAPITAL LETTER E */
 /* 0x8265 */ 0xFF26 , /* FULLWIDTH LATIN CAPITAL LETTER F */
 /* 0x8266 */ 0xFF27 , /* FULLWIDTH LATIN CAPITAL LETTER G */
 /* 0x8267 */ 0xFF28 , /* FULLWIDTH LATIN CAPITAL LETTER H */
 /* 0x8268 */ 0xFF29 , /* FULLWIDTH LATIN CAPITAL LETTER I */
 /* 0x8269 */ 0xFF2A , /* FULLWIDTH LATIN CAPITAL LETTER J */
 /* 0x826A */ 0xFF2B , /* FULLWIDTH LATIN CAPITAL LETTER K */
 /* 0x826B */ 0xFF2C , /* FULLWIDTH LATIN CAPITAL LETTER L */
 /* 0x826C */ 0xFF2D , /* FULLWIDTH LATIN CAPITAL LETTER M */
 /* 0x826D */ 0xFF2E , /* FULLWIDTH LATIN CAPITAL LETTER N */
 /* 0x826E */ 0xFF2F , /* FULLWIDTH LATIN CAPITAL LETTER O */
 /* 0x826F */ 0xFF30 , /* FULLWIDTH LATIN CAPITAL LETTER P */
 /* 0x8270 */ 0xFF31 , /* FULLWIDTH LATIN CAPITAL LETTER Q */
 /* 0x8271 */ 0xFF32 , /* FULLWIDTH LATIN CAPITAL LETTER R */
 /* 0x8272 */ 0xFF33 , /* FULLWIDTH LATIN CAPITAL LETTER S */
 /* 0x8273 */ 0xFF34 , /* FULLWIDTH LATIN CAPITAL LETTER T */
 /* 0x8274 */ 0xFF35 , /* FULLWIDTH LATIN CAPITAL LETTER U */
 /* 0x8275 */ 0xFF36 , /* FULLWIDTH LATIN CAPITAL LETTER V */
 /* 0x8276 */ 0xFF37 , /* FULLWIDTH LATIN CAPITAL LETTER W */
 /* 0x8277 */ 0xFF38 , /* FULLWIDTH LATIN CAPITAL LETTER X */
 /* 0x8278 */ 0xFF39 , /* FULLWIDTH LATIN CAPITAL LETTER Y */
 /* 0x8279 */ 0xFF3A , /* FULLWIDTH LATIN CAPITAL LETTER Z */
 /* 0x827A */ 0xFFFF ,
 /* 0x827B */ 0xFFFF ,
 /* 0x827C */ 0xFFFF ,
 /* 0x827D */ 0xFFFF ,
 /* 0x827E */ 0xFFFF ,
 /* 0x8280 */ 0xFFFF ,
 /* 0x8281 */ 0xFF41 , /* FULLWIDTH LATIN SMALL LETTER A */
 /* 0x8282 */ 0xFF42 , /* FULLWIDTH LATIN SMALL LETTER B */
 /* 0x8283 */ 0xFF43 , /* FULLWIDTH LATIN SMALL LETTER C */
 /* 0x8284 */ 0xFF44 , /* FULLWIDTH LATIN SMALL LETTER D */
 /* 0x8285 */ 0xFF45 , /* FULLWIDTH LATIN SMALL LETTER E */
 /* 0x8286 */ 0xFF46 , /* FULLWIDTH LATIN SMALL LETTER F */
 /* 0x8287 */ 0xFF47 , /* FULLWIDTH LATIN SMALL LETTER G */
 /* 0x8288 */ 0xFF48 , /* FULLWIDTH LATIN SMALL LETTER H */
 /* 0x8289 */ 0xFF49 , /* FULLWIDTH LATIN SMALL LETTER I */
 /* 0x828A */ 0xFF4A , /* FULLWIDTH LATIN SMALL LETTER J */
 /* 0x828B */ 0xFF4B , /* FULLWIDTH LATIN SMALL LETTER K */
 /* 0x828C */ 0xFF4C , /* FULLWIDTH LATIN SMALL LETTER L */
 /* 0x828D */ 0xFF4D , /* FULLWIDTH LATIN SMALL LETTER M */
 /* 0x828E */ 0xFF4E , /* FULLWIDTH LATIN SMALL LETTER N */
 /* 0x828F */ 0xFF4F , /* FULLWIDTH LATIN SMALL LETTER O */
 /* 0x8290 */ 0xFF50 , /* FULLWIDTH LATIN SMALL LETTER P */
 /* 0x8291 */ 0xFF51 , /* FULLWIDTH LATIN SMALL LETTER Q */
 /* 0x8292 */ 0xFF52 , /* FULLWIDTH LATIN SMALL LETTER R */
 /* 0x8293 */ 0xFF53 , /* FULLWIDTH LATIN SMALL LETTER S */
 /* 0x8294 */ 0xFF54 , /* FULLWIDTH LATIN SMALL LETTER T */
 /* 0x8295 */ 0xFF55 , /* FULLWIDTH LATIN SMALL LETTER U */
 /* 0x8296 */ 0xFF56 , /* FULLWIDTH LATIN SMALL LETTER V */
 /* 0x8297 */ 0xFF57 , /* FULLWIDTH LATIN SMALL LETTER W */
 /* 0x8298 */ 0xFF58 , /* FULLWIDTH LATIN SMALL LETTER X */
 /* 0x8299 */ 0xFF59 , /* FULLWIDTH LATIN SMALL LETTER Y */
 /* 0x829A */ 0xFF5A , /* FULLWIDTH LATIN SMALL LETTER Z */
 /* 0x829B */ 0xFFFF ,
 /* 0x829C */ 0xFFFF ,
 /* 0x829D */ 0xFFFF ,
 /* 0x829E */ 0xFFFF ,
 /* 0x829F */ 0x3041 , /* HIRAGANA LETTER SMALL A */
 /* 0x82A0 */ 0x3042 , /* HIRAGANA LETTER A */
 /* 0x82A1 */ 0x3043 , /* HIRAGANA LETTER SMALL I */
 /* 0x82A2 */ 0x3044 , /* HIRAGANA LETTER I */
 /* 0x82A3 */ 0x3045 , /* HIRAGANA LETTER SMALL U */
 /* 0x82A4 */ 0x3046 , /* HIRAGANA LETTER U */
 /* 0x82A5 */ 0x3047 , /* HIRAGANA LETTER SMALL E */
 /* 0x82A6 */ 0x3048 , /* HIRAGANA LETTER E */
 /* 0x82A7 */ 0x3049 , /* HIRAGANA LETTER SMALL O */
 /* 0x82A8 */ 0x304A , /* HIRAGANA LETTER O */
 /* 0x82A9 */ 0x304B , /* HIRAGANA LETTER KA */
 /* 0x82AA */ 0x304C , /* HIRAGANA LETTER GA */
 /* 0x82AB */ 0x304D , /* HIRAGANA LETTER KI */
 /* 0x82AC */ 0x304E , /* HIRAGANA LETTER GI */
 /* 0x82AD */ 0x304F , /* HIRAGANA LETTER KU */
 /* 0x82AE */ 0x3050 , /* HIRAGANA LETTER GU */
 /* 0x82AF */ 0x3051 , /* HIRAGANA LETTER KE */
 /* 0x82B0 */ 0x3052 , /* HIRAGANA LETTER GE */
 /* 0x82B1 */ 0x3053 , /* HIRAGANA LETTER KO */
 /* 0x82B2 */ 0x3054 , /* HIRAGANA LETTER GO */
 /* 0x82B3 */ 0x3055 , /* HIRAGANA LETTER SA */
 /* 0x82B4 */ 0x3056 , /* HIRAGANA LETTER ZA */
 /* 0x82B5 */ 0x3057 , /* HIRAGANA LETTER SI */
 /* 0x82B6 */ 0x3058 , /* HIRAGANA LETTER ZI */
 /* 0x82B7 */ 0x3059 , /* HIRAGANA LETTER SU */
 /* 0x82B8 */ 0x305A , /* HIRAGANA LETTER ZU */
 /* 0x82B9 */ 0x305B , /* HIRAGANA LETTER SE */
 /* 0x82BA */ 0x305C , /* HIRAGANA LETTER ZE */
 /* 0x82BB */ 0x305D , /* HIRAGANA LETTER SO */
 /* 0x82BC */ 0x305E , /* HIRAGANA LETTER ZO */
 /* 0x82BD */ 0x305F , /* HIRAGANA LETTER TA */
 /* 0x82BE */ 0x3060 , /* HIRAGANA LETTER DA */
 /* 0x82BF */ 0x3061 , /* HIRAGANA LETTER TI */
 /* 0x82C0 */ 0x3062 , /* HIRAGANA LETTER DI */
 /* 0x82C1 */ 0x3063 , /* HIRAGANA LETTER SMALL TU */
 /* 0x82C2 */ 0x3064 , /* HIRAGANA LETTER TU */
 /* 0x82C3 */ 0x3065 , /* HIRAGANA LETTER DU */
 /* 0x82C4 */ 0x3066 , /* HIRAGANA LETTER TE */
 /* 0x82C5 */ 0x3067 , /* HIRAGANA LETTER DE */
 /* 0x82C6 */ 0x3068 , /* HIRAGANA LETTER TO */
 /* 0x82C7 */ 0x3069 , /* HIRAGANA LETTER DO */
 /* 0x82C8 */ 0x306A , /* HIRAGANA LETTER NA */
 /* 0x82C9 */ 0x306B , /* HIRAGANA LETTER NI */
 /* 0x82CA */ 0x306C , /* HIRAGANA LETTER NU */
 /* 0x82CB */ 0x306D , /* HIRAGANA LETTER NE */
 /* 0x82CC */ 0x306E , /* HIRAGANA LETTER NO */
 /* 0x82CD */ 0x306F , /* HIRAGANA LETTER HA */
 /* 0x82CE */ 0x3070 , /* HIRAGANA LETTER BA */
 /* 0x82CF */ 0x3071 , /* HIRAGANA LETTER PA */
 /* 0x82D0 */ 0x3072 , /* HIRAGANA LETTER HI */
 /* 0x82D1 */ 0x3073 , /* HIRAGANA LETTER BI */
 /* 0x82D2 */ 0x3074 , /* HIRAGANA LETTER PI */
 /* 0x82D3 */ 0x3075 , /* HIRAGANA LETTER HU */
 /* 0x82D4 */ 0x3076 , /* HIRAGANA LETTER BU */
 /* 0x82D5 */ 0x3077 , /* HIRAGANA LETTER PU */
 /* 0x82D6 */ 0x3078 , /* HIRAGANA LETTER HE */
 /* 0x82D7 */ 0x3079 , /* HIRAGANA LETTER BE */
 /* 0x82D8 */ 0x307A , /* HIRAGANA LETTER PE */
 /* 0x82D9 */ 0x307B , /* HIRAGANA LETTER HO */
 /* 0x82DA */ 0x307C , /* HIRAGANA LETTER BO */
 /* 0x82DB */ 0x307D , /* HIRAGANA LETTER PO */
 /* 0x82DC */ 0x307E , /* HIRAGANA LETTER MA */
 /* 0x82DD */ 0x307F , /* HIRAGANA LETTER MI */
 /* 0x82DE */ 0x3080 , /* HIRAGANA LETTER MU */
 /* 0x82DF */ 0x3081 , /* HIRAGANA LETTER ME */
 /* 0x82E0 */ 0x3082 , /* HIRAGANA LETTER MO */
 /* 0x82E1 */ 0x3083 , /* HIRAGANA LETTER SMALL YA */
 /* 0x82E2 */ 0x3084 , /* HIRAGANA LETTER YA */
 /* 0x82E3 */ 0x3085 , /* HIRAGANA LETTER SMALL YU */
 /* 0x82E4 */ 0x3086 , /* HIRAGANA LETTER YU */
 /* 0x82E5 */ 0x3087 , /* HIRAGANA LETTER SMALL YO */
 /* 0x82E6 */ 0x3088 , /* HIRAGANA LETTER YO */
 /* 0x82E7 */ 0x3089 , /* HIRAGANA LETTER RA */
 /* 0x82E8 */ 0x308A , /* HIRAGANA LETTER RI */
 /* 0x82E9 */ 0x308B , /* HIRAGANA LETTER RU */
 /* 0x82EA */ 0x308C , /* HIRAGANA LETTER RE */
 /* 0x82EB */ 0x308D , /* HIRAGANA LETTER RO */
 /* 0x82EC */ 0x308E , /* HIRAGANA LETTER SMALL WA */
 /* 0x82ED */ 0x308F , /* HIRAGANA LETTER WA */
 /* 0x82EE */ 0x3090 , /* HIRAGANA LETTER WI */
 /* 0x82EF */ 0x3091 , /* HIRAGANA LETTER WE */
 /* 0x82F0 */ 0x3092 , /* HIRAGANA LETTER WO */
 /* 0x82F1 */ 0x3093 , /* HIRAGANA LETTER N */
 /* 0x82F2 */ 0xFFFF ,
 /* 0x82F3 */ 0xFFFF ,
 /* 0x82F4 */ 0xFFFF ,
 /* 0x82F5 */ 0xFFFF ,
 /* 0x82F6 */ 0xFFFF ,
 /* 0x82F7 */ 0xFFFF ,
 /* 0x82F8 */ 0xFFFF ,
 /* 0x82F9 */ 0xFFFF ,
 /* 0x82FA */ 0xFFFF ,
 /* 0x82FB */ 0xFFFF ,
 /* 0x82FC */ 0xFFFF ,
 /* 0x8340 */ 0x30A1 , /* KATAKANA LETTER SMALL A */
 /* 0x8341 */ 0x30A2 , /* KATAKANA LETTER A */
 /* 0x8342 */ 0x30A3 , /* KATAKANA LETTER SMALL I */
 /* 0x8343 */ 0x30A4 , /* KATAKANA LETTER I */
 /* 0x8344 */ 0x30A5 , /* KATAKANA LETTER SMALL U */
 /* 0x8345 */ 0x30A6 , /* KATAKANA LETTER U */
 /* 0x8346 */ 0x30A7 , /* KATAKANA LETTER SMALL E */
 /* 0x8347 */ 0x30A8 , /* KATAKANA LETTER E */
 /* 0x8348 */ 0x30A9 , /* KATAKANA LETTER SMALL O */
 /* 0x8349 */ 0x30AA , /* KATAKANA LETTER O */
 /* 0x834A */ 0x30AB , /* KATAKANA LETTER KA */
 /* 0x834B */ 0x30AC , /* KATAKANA LETTER GA */
 /* 0x834C */ 0x30AD , /* KATAKANA LETTER KI */
 /* 0x834D */ 0x30AE , /* KATAKANA LETTER GI */
 /* 0x834E */ 0x30AF , /* KATAKANA LETTER KU */
 /* 0x834F */ 0x30B0 , /* KATAKANA LETTER GU */
 /* 0x8350 */ 0x30B1 , /* KATAKANA LETTER KE */
 /* 0x8351 */ 0x30B2 , /* KATAKANA LETTER GE */
 /* 0x8352 */ 0x30B3 , /* KATAKANA LETTER KO */
 /* 0x8353 */ 0x30B4 , /* KATAKANA LETTER GO */
 /* 0x8354 */ 0x30B5 , /* KATAKANA LETTER SA */
 /* 0x8355 */ 0x30B6 , /* KATAKANA LETTER ZA */
 /* 0x8356 */ 0x30B7 , /* KATAKANA LETTER SI */
 /* 0x8357 */ 0x30B8 , /* KATAKANA LETTER ZI */
 /* 0x8358 */ 0x30B9 , /* KATAKANA LETTER SU */
 /* 0x8359 */ 0x30BA , /* KATAKANA LETTER ZU */
 /* 0x835A */ 0x30BB , /* KATAKANA LETTER SE */
 /* 0x835B */ 0x30BC , /* KATAKANA LETTER ZE */
 /* 0x835C */ 0x30BD , /* KATAKANA LETTER SO */
 /* 0x835D */ 0x30BE , /* KATAKANA LETTER ZO */
 /* 0x835E */ 0x30BF , /* KATAKANA LETTER TA */
 /* 0x835F */ 0x30C0 , /* KATAKANA LETTER DA */
 /* 0x8360 */ 0x30C1 , /* KATAKANA LETTER TI */
 /* 0x8361 */ 0x30C2 , /* KATAKANA LETTER DI */
 /* 0x8362 */ 0x30C3 , /* KATAKANA LETTER SMALL TU */
 /* 0x8363 */ 0x30C4 , /* KATAKANA LETTER TU */
 /* 0x8364 */ 0x30C5 , /* KATAKANA LETTER DU */
 /* 0x8365 */ 0x30C6 , /* KATAKANA LETTER TE */
 /* 0x8366 */ 0x30C7 , /* KATAKANA LETTER DE */
 /* 0x8367 */ 0x30C8 , /* KATAKANA LETTER TO */
 /* 0x8368 */ 0x30C9 , /* KATAKANA LETTER DO */
 /* 0x8369 */ 0x30CA , /* KATAKANA LETTER NA */
 /* 0x836A */ 0x30CB , /* KATAKANA LETTER NI */
 /* 0x836B */ 0x30CC , /* KATAKANA LETTER NU */
 /* 0x836C */ 0x30CD , /* KATAKANA LETTER NE */
 /* 0x836D */ 0x30CE , /* KATAKANA LETTER NO */
 /* 0x836E */ 0x30CF , /* KATAKANA LETTER HA */
 /* 0x836F */ 0x30D0 , /* KATAKANA LETTER BA */
 /* 0x8370 */ 0x30D1 , /* KATAKANA LETTER PA */
 /* 0x8371 */ 0x30D2 , /* KATAKANA LETTER HI */
 /* 0x8372 */ 0x30D3 , /* KATAKANA LETTER BI */
 /* 0x8373 */ 0x30D4 , /* KATAKANA LETTER PI */
 /* 0x8374 */ 0x30D5 , /* KATAKANA LETTER HU */
 /* 0x8375 */ 0x30D6 , /* KATAKANA LETTER BU */
 /* 0x8376 */ 0x30D7 , /* KATAKANA LETTER PU */
 /* 0x8377 */ 0x30D8 , /* KATAKANA LETTER HE */
 /* 0x8378 */ 0x30D9 , /* KATAKANA LETTER BE */
 /* 0x8379 */ 0x30DA , /* KATAKANA LETTER PE */
 /* 0x837A */ 0x30DB , /* KATAKANA LETTER HO */
 /* 0x837B */ 0x30DC , /* KATAKANA LETTER BO */
 /* 0x837C */ 0x30DD , /* KATAKANA LETTER PO */
 /* 0x837D */ 0x30DE , /* KATAKANA LETTER MA */
 /* 0x837E */ 0x30DF , /* KATAKANA LETTER MI */
 /* 0x8380 */ 0x30E0 , /* KATAKANA LETTER MU */
 /* 0x8381 */ 0x30E1 , /* KATAKANA LETTER ME */
 /* 0x8382 */ 0x30E2 , /* KATAKANA LETTER MO */
 /* 0x8383 */ 0x30E3 , /* KATAKANA LETTER SMALL YA */
 /* 0x8384 */ 0x30E4 , /* KATAKANA LETTER YA */
 /* 0x8385 */ 0x30E5 , /* KATAKANA LETTER SMALL YU */
 /* 0x8386 */ 0x30E6 , /* KATAKANA LETTER YU */
 /* 0x8387 */ 0x30E7 , /* KATAKANA LETTER SMALL YO */
 /* 0x8388 */ 0x30E8 , /* KATAKANA LETTER YO */
 /* 0x8389 */ 0x30E9 , /* KATAKANA LETTER RA */
 /* 0x838A */ 0x30EA , /* KATAKANA LETTER RI */
 /* 0x838B */ 0x30EB , /* KATAKANA LETTER RU */
 /* 0x838C */ 0x30EC , /* KATAKANA LETTER RE */
 /* 0x838D */ 0x30ED , /* KATAKANA LETTER RO */
 /* 0x838E */ 0x30EE , /* KATAKANA LETTER SMALL WA */
 /* 0x838F */ 0x30EF , /* KATAKANA LETTER WA */
 /* 0x8390 */ 0x30F0 , /* KATAKANA LETTER WI */
 /* 0x8391 */ 0x30F1 , /* KATAKANA LETTER WE */
 /* 0x8392 */ 0x30F2 , /* KATAKANA LETTER WO */
 /* 0x8393 */ 0x30F3 , /* KATAKANA LETTER N */
 /* 0x8394 */ 0x30F4 , /* KATAKANA LETTER VU */
 /* 0x8395 */ 0x30F5 , /* KATAKANA LETTER SMALL KA */
 /* 0x8396 */ 0x30F6 , /* KATAKANA LETTER SMALL KE */
 /* 0x8397 */ 0xFFFF ,
 /* 0x8398 */ 0xFFFF ,
 /* 0x8399 */ 0xFFFF ,
 /* 0x839A */ 0xFFFF ,
 /* 0x839B */ 0xFFFF ,
 /* 0x839C */ 0xFFFF ,
 /* 0x839D */ 0xFFFF ,
 /* 0x839E */ 0xFFFF ,
 /* 0x839F */ 0x0391 , /* GREEK CAPITAL LETTER ALPHA */
 /* 0x83A0 */ 0x0392 , /* GREEK CAPITAL LETTER BETA */
 /* 0x83A1 */ 0x0393 , /* GREEK CAPITAL LETTER GAMMA */
 /* 0x83A2 */ 0x0394 , /* GREEK CAPITAL LETTER DELTA */
 /* 0x83A3 */ 0x0395 , /* GREEK CAPITAL LETTER EPSILON */
 /* 0x83A4 */ 0x0396 , /* GREEK CAPITAL LETTER ZETA */
 /* 0x83A5 */ 0x0397 , /* GREEK CAPITAL LETTER ETA */
 /* 0x83A6 */ 0x0398 , /* GREEK CAPITAL LETTER THETA */
 /* 0x83A7 */ 0x0399 , /* GREEK CAPITAL LETTER IOTA */
 /* 0x83A8 */ 0x039A , /* GREEK CAPITAL LETTER KAPPA */
 /* 0x83A9 */ 0x039B , /* GREEK CAPITAL LETTER LAMDA */
 /* 0x83AA */ 0x039C , /* GREEK CAPITAL LETTER MU */
 /* 0x83AB */ 0x039D , /* GREEK CAPITAL LETTER NU */
 /* 0x83AC */ 0x039E , /* GREEK CAPITAL LETTER XI */
 /* 0x83AD */ 0x039F , /* GREEK CAPITAL LETTER OMICRON */
 /* 0x83AE */ 0x03A0 , /* GREEK CAPITAL LETTER PI */
 /* 0x83AF */ 0x03A1 , /* GREEK CAPITAL LETTER RHO */
 /* 0x83B0 */ 0x03A3 , /* GREEK CAPITAL LETTER SIGMA */
 /* 0x83B1 */ 0x03A4 , /* GREEK CAPITAL LETTER TAU */
 /* 0x83B2 */ 0x03A5 , /* GREEK CAPITAL LETTER UPSILON */
 /* 0x83B3 */ 0x03A6 , /* GREEK CAPITAL LETTER PHI */
 /* 0x83B4 */ 0x03A7 , /* GREEK CAPITAL LETTER CHI */
 /* 0x83B5 */ 0x03A8 , /* GREEK CAPITAL LETTER PSI */
 /* 0x83B6 */ 0x03A9 , /* GREEK CAPITAL LETTER OMEGA */
 /* 0x83B7 */ 0xFFFF ,
 /* 0x83B8 */ 0xFFFF ,
 /* 0x83B9 */ 0xFFFF ,
 /* 0x83BA */ 0xFFFF ,
 /* 0x83BB */ 0xFFFF ,
 /* 0x83BC */ 0xFFFF ,
 /* 0x83BD */ 0xFFFF ,
 /* 0x83BE */ 0xFFFF ,
 /* 0x83BF */ 0x03B1 , /* GREEK SMALL LETTER ALPHA */
 /* 0x83C0 */ 0x03B2 , /* GREEK SMALL LETTER BETA */
 /* 0x83C1 */ 0x03B3 , /* GREEK SMALL LETTER GAMMA */
 /* 0x83C2 */ 0x03B4 , /* GREEK SMALL LETTER DELTA */
 /* 0x83C3 */ 0x03B5 , /* GREEK SMALL LETTER EPSILON */
 /* 0x83C4 */ 0x03B6 , /* GREEK SMALL LETTER ZETA */
 /* 0x83C5 */ 0x03B7 , /* GREEK SMALL LETTER ETA */
 /* 0x83C6 */ 0x03B8 , /* GREEK SMALL LETTER THETA */
 /* 0x83C7 */ 0x03B9 , /* GREEK SMALL LETTER IOTA */
 /* 0x83C8 */ 0x03BA , /* GREEK SMALL LETTER KAPPA */
 /* 0x83C9 */ 0x03BB , /* GREEK SMALL LETTER LAMDA */
 /* 0x83CA */ 0x03BC , /* GREEK SMALL LETTER MU */
 /* 0x83CB */ 0x03BD , /* GREEK SMALL LETTER NU */
 /* 0x83CC */ 0x03BE , /* GREEK SMALL LETTER XI */
 /* 0x83CD */ 0x03BF , /* GREEK SMALL LETTER OMICRON */
 /* 0x83CE */ 0x03C0 , /* GREEK SMALL LETTER PI */
 /* 0x83CF */ 0x03C1 , /* GREEK SMALL LETTER RHO */
 /* 0x83D0 */ 0x03C3 , /* GREEK SMALL LETTER SIGMA */
 /* 0x83D1 */ 0x03C4 , /* GREEK SMALL LETTER TAU */
 /* 0x83D2 */ 0x03C5 , /* GREEK SMALL LETTER UPSILON */
 /* 0x83D3 */ 0x03C6 , /* GREEK SMALL LETTER PHI */
 /* 0x83D4 */ 0x03C7 , /* GREEK SMALL LETTER CHI */
 /* 0x83D5 */ 0x03C8 , /* GREEK SMALL LETTER PSI */
 /* 0x83D6 */ 0x03C9 , /* GREEK SMALL LETTER OMEGA */
 /* 0x83D7 */ 0xFFFF ,
 /* 0x83D8 */ 0xFFFF ,
 /* 0x83D9 */ 0xFFFF ,
 /* 0x83DA */ 0xFFFF ,
 /* 0x83DB */ 0xFFFF ,
 /* 0x83DC */ 0xFFFF ,
 /* 0x83DD */ 0xFFFF ,
 /* 0x83DE */ 0xFFFF ,
 /* 0x83DF */ 0xFFFF ,
 /* 0x83E0 */ 0xFFFF ,
 /* 0x83E1 */ 0xFFFF ,
 /* 0x83E2 */ 0xFFFF ,
 /* 0x83E3 */ 0xFFFF ,
 /* 0x83E4 */ 0xFFFF ,
 /* 0x83E5 */ 0xFFFF ,
 /* 0x83E6 */ 0xFFFF ,
 /* 0x83E7 */ 0xFFFF ,
 /* 0x83E8 */ 0xFFFF ,
 /* 0x83E9 */ 0xFFFF ,
 /* 0x83EA */ 0xFFFF ,
 /* 0x83EB */ 0xFFFF ,
 /* 0x83EC */ 0xFFFF ,
 /* 0x83ED */ 0xFFFF ,
 /* 0x83EE */ 0xFFFF ,
 /* 0x83EF */ 0xFFFF ,
 /* 0x83F0 */ 0xFFFF ,
 /* 0x83F1 */ 0xFFFF ,
 /* 0x83F2 */ 0xFFFF ,
 /* 0x83F3 */ 0xFFFF ,
 /* 0x83F4 */ 0xFFFF ,
 /* 0x83F5 */ 0xFFFF ,
 /* 0x83F6 */ 0xFFFF ,
 /* 0x83F7 */ 0xFFFF ,
 /* 0x83F8 */ 0xFFFF ,
 /* 0x83F9 */ 0xFFFF ,
 /* 0x83FA */ 0xFFFF ,
 /* 0x83FB */ 0xFFFF ,
 /* 0x83FC */ 0xFFFF ,
 /* 0x8440 */ 0x0410 , /* CYRILLIC CAPITAL LETTER A */
 /* 0x8441 */ 0x0411 , /* CYRILLIC CAPITAL LETTER BE */
 /* 0x8442 */ 0x0412 , /* CYRILLIC CAPITAL LETTER VE */
 /* 0x8443 */ 0x0413 , /* CYRILLIC CAPITAL LETTER GHE */
 /* 0x8444 */ 0x0414 , /* CYRILLIC CAPITAL LETTER DE */
 /* 0x8445 */ 0x0415 , /* CYRILLIC CAPITAL LETTER IE */
 /* 0x8446 */ 0x0401 , /* CYRILLIC CAPITAL LETTER IO */
 /* 0x8447 */ 0x0416 , /* CYRILLIC CAPITAL LETTER ZHE */
 /* 0x8448 */ 0x0417 , /* CYRILLIC CAPITAL LETTER ZE */
 /* 0x8449 */ 0x0418 , /* CYRILLIC CAPITAL LETTER I */
 /* 0x844A */ 0x0419 , /* CYRILLIC CAPITAL LETTER SHORT I */
 /* 0x844B */ 0x041A , /* CYRILLIC CAPITAL LETTER KA */
 /* 0x844C */ 0x041B , /* CYRILLIC CAPITAL LETTER EL */
 /* 0x844D */ 0x041C , /* CYRILLIC CAPITAL LETTER EM */
 /* 0x844E */ 0x041D , /* CYRILLIC CAPITAL LETTER EN */
 /* 0x844F */ 0x041E , /* CYRILLIC CAPITAL LETTER O */
 /* 0x8450 */ 0x041F , /* CYRILLIC CAPITAL LETTER PE */
 /* 0x8451 */ 0x0420 , /* CYRILLIC CAPITAL LETTER ER */
 /* 0x8452 */ 0x0421 , /* CYRILLIC CAPITAL LETTER ES */
 /* 0x8453 */ 0x0422 , /* CYRILLIC CAPITAL LETTER TE */
 /* 0x8454 */ 0x0423 , /* CYRILLIC CAPITAL LETTER U */
 /* 0x8455 */ 0x0424 , /* CYRILLIC CAPITAL LETTER EF */
 /* 0x8456 */ 0x0425 , /* CYRILLIC CAPITAL LETTER HA */
 /* 0x8457 */ 0x0426 , /* CYRILLIC CAPITAL LETTER TSE */
 /* 0x8458 */ 0x0427 , /* CYRILLIC CAPITAL LETTER CHE */
 /* 0x8459 */ 0x0428 , /* CYRILLIC CAPITAL LETTER SHA */
 /* 0x845A */ 0x0429 , /* CYRILLIC CAPITAL LETTER SHCHA */
 /* 0x845B */ 0x042A , /* CYRILLIC CAPITAL LETTER HARD SIGN */
 /* 0x845C */ 0x042B , /* CYRILLIC CAPITAL LETTER YERU */
 /* 0x845D */ 0x042C , /* CYRILLIC CAPITAL LETTER SOFT SIGN */
 /* 0x845E */ 0x042D , /* CYRILLIC CAPITAL LETTER E */
 /* 0x845F */ 0x042E , /* CYRILLIC CAPITAL LETTER YU */
 /* 0x8460 */ 0x042F , /* CYRILLIC CAPITAL LETTER YA */
 /* 0x8461 */ 0xFFFF ,
 /* 0x8462 */ 0xFFFF ,
 /* 0x8463 */ 0xFFFF ,
 /* 0x8464 */ 0xFFFF ,
 /* 0x8465 */ 0xFFFF ,
 /* 0x8466 */ 0xFFFF ,
 /* 0x8467 */ 0xFFFF ,
 /* 0x8468 */ 0xFFFF ,
 /* 0x8469 */ 0xFFFF ,
 /* 0x846A */ 0xFFFF ,
 /* 0x846B */ 0xFFFF ,
 /* 0x846C */ 0xFFFF ,
 /* 0x846D */ 0xFFFF ,
 /* 0x846E */ 0xFFFF ,
 /* 0x846F */ 0xFFFF ,
 /* 0x8470 */ 0x0430 , /* CYRILLIC SMALL LETTER A */
 /* 0x8471 */ 0x0431 , /* CYRILLIC SMALL LETTER BE */
 /* 0x8472 */ 0x0432 , /* CYRILLIC SMALL LETTER VE */
 /* 0x8473 */ 0x0433 , /* CYRILLIC SMALL LETTER GHE */
 /* 0x8474 */ 0x0434 , /* CYRILLIC SMALL LETTER DE */
 /* 0x8475 */ 0x0435 , /* CYRILLIC SMALL LETTER IE */
 /* 0x8476 */ 0x0451 , /* CYRILLIC SMALL LETTER IO */
 /* 0x8477 */ 0x0436 , /* CYRILLIC SMALL LETTER ZHE */
 /* 0x8478 */ 0x0437 , /* CYRILLIC SMALL LETTER ZE */
 /* 0x8479 */ 0x0438 , /* CYRILLIC SMALL LETTER I */
 /* 0x847A */ 0x0439 , /* CYRILLIC SMALL LETTER SHORT I */
 /* 0x847B */ 0x043A , /* CYRILLIC SMALL LETTER KA */
 /* 0x847C */ 0x043B , /* CYRILLIC SMALL LETTER EL */
 /* 0x847D */ 0x043C , /* CYRILLIC SMALL LETTER EM */
 /* 0x847E */ 0x043D , /* CYRILLIC SMALL LETTER EN */
 /* 0x8480 */ 0x043E , /* CYRILLIC SMALL LETTER O */
 /* 0x8481 */ 0x043F , /* CYRILLIC SMALL LETTER PE */
 /* 0x8482 */ 0x0440 , /* CYRILLIC SMALL LETTER ER */
 /* 0x8483 */ 0x0441 , /* CYRILLIC SMALL LETTER ES */
 /* 0x8484 */ 0x0442 , /* CYRILLIC SMALL LETTER TE */
 /* 0x8485 */ 0x0443 , /* CYRILLIC SMALL LETTER U */
 /* 0x8486 */ 0x0444 , /* CYRILLIC SMALL LETTER EF */
 /* 0x8487 */ 0x0445 , /* CYRILLIC SMALL LETTER HA */
 /* 0x8488 */ 0x0446 , /* CYRILLIC SMALL LETTER TSE */
 /* 0x8489 */ 0x0447 , /* CYRILLIC SMALL LETTER CHE */
 /* 0x848A */ 0x0448 , /* CYRILLIC SMALL LETTER SHA */
 /* 0x848B */ 0x0449 , /* CYRILLIC SMALL LETTER SHCHA */
 /* 0x848C */ 0x044A , /* CYRILLIC SMALL LETTER HARD SIGN */
 /* 0x848D */ 0x044B , /* CYRILLIC SMALL LETTER YERU */
 /* 0x848E */ 0x044C , /* CYRILLIC SMALL LETTER SOFT SIGN */
 /* 0x848F */ 0x044D , /* CYRILLIC SMALL LETTER E */
 /* 0x8490 */ 0x044E , /* CYRILLIC SMALL LETTER YU */
 /* 0x8491 */ 0x044F , /* CYRILLIC SMALL LETTER YA */
 /* 0x8492 */ 0xFFFF ,
 /* 0x8493 */ 0xFFFF ,
 /* 0x8494 */ 0xFFFF ,
 /* 0x8495 */ 0xFFFF ,
 /* 0x8496 */ 0xFFFF ,
 /* 0x8497 */ 0xFFFF ,
 /* 0x8498 */ 0xFFFF ,
 /* 0x8499 */ 0xFFFF ,
 /* 0x849A */ 0xFFFF ,
 /* 0x849B */ 0xFFFF ,
 /* 0x849C */ 0xFFFF ,
 /* 0x849D */ 0xFFFF ,
 /* 0x849E */ 0xFFFF ,
 /* 0x849F */ 0x2500 , /* BOX DRAWINGS LIGHT HORIZONTAL */
 /* 0x84A0 */ 0x2502 , /* BOX DRAWINGS LIGHT VERTICAL */
 /* 0x84A1 */ 0x250C , /* BOX DRAWINGS LIGHT DOWN AND RIGHT */
 /* 0x84A2 */ 0x2510 , /* BOX DRAWINGS LIGHT DOWN AND LEFT */
 /* 0x84A3 */ 0x2518 , /* BOX DRAWINGS LIGHT UP AND LEFT */
 /* 0x84A4 */ 0x2514 , /* BOX DRAWINGS LIGHT UP AND RIGHT */
 /* 0x84A5 */ 0x251C , /* BOX DRAWINGS LIGHT VERTICAL AND RIGHT */
 /* 0x84A6 */ 0x252C , /* BOX DRAWINGS LIGHT DOWN AND HORIZONTAL */
 /* 0x84A7 */ 0x2524 , /* BOX DRAWINGS LIGHT VERTICAL AND LEFT */
 /* 0x84A8 */ 0x2534 , /* BOX DRAWINGS LIGHT UP AND HORIZONTAL */
 /* 0x84A9 */ 0x253C , /* BOX DRAWINGS LIGHT VERTICAL AND HORIZONTAL */
 /* 0x84AA */ 0x2501 , /* BOX DRAWINGS HEAVY HORIZONTAL */
 /* 0x84AB */ 0x2503 , /* BOX DRAWINGS HEAVY VERTICAL */
 /* 0x84AC */ 0x250F , /* BOX DRAWINGS HEAVY DOWN AND RIGHT */
 /* 0x84AD */ 0x2513 , /* BOX DRAWINGS HEAVY DOWN AND LEFT */
 /* 0x84AE */ 0x251B , /* BOX DRAWINGS HEAVY UP AND LEFT */
 /* 0x84AF */ 0x2517 , /* BOX DRAWINGS HEAVY UP AND RIGHT */
 /* 0x84B0 */ 0x2523 , /* BOX DRAWINGS HEAVY VERTICAL AND RIGHT */
 /* 0x84B1 */ 0x2533 , /* BOX DRAWINGS HEAVY DOWN AND HORIZONTAL */
 /* 0x84B2 */ 0x252B , /* BOX DRAWINGS HEAVY VERTICAL AND LEFT */
 /* 0x84B3 */ 0x253B , /* BOX DRAWINGS HEAVY UP AND HORIZONTAL */
 /* 0x84B4 */ 0x254B , /* BOX DRAWINGS HEAVY VERTICAL AND HORIZONTAL */
 /* 0x84B5 */ 0x2520 , /* BOX DRAWINGS VERTICAL HEAVY AND RIGHT LIGHT */
 /* 0x84B6 */ 0x252F , /* BOX DRAWINGS DOWN LIGHT AND HORIZONTAL HEAVY */
 /* 0x84B7 */ 0x2528 , /* BOX DRAWINGS VERTICAL HEAVY AND LEFT LIGHT */
 /* 0x84B8 */ 0x2537 , /* BOX DRAWINGS UP LIGHT AND HORIZONTAL HEAVY */
 /* 0x84B9 */ 0x253F , /* BOX DRAWINGS VERTICAL LIGHT AND HORIZONTAL HEAVY */
 /* 0x84BA */ 0x251D , /* BOX DRAWINGS VERTICAL LIGHT AND RIGHT HEAVY */
 /* 0x84BB */ 0x2530 , /* BOX DRAWINGS DOWN HEAVY AND HORIZONTAL LIGHT */
 /* 0x84BC */ 0x2525 , /* BOX DRAWINGS VERTICAL LIGHT AND LEFT HEAVY */
 /* 0x84BD */ 0x2538 , /* BOX DRAWINGS UP HEAVY AND HORIZONTAL LIGHT */
 /* 0x84BE */ 0x2542 , /* BOX DRAWINGS VERTICAL HEAVY AND HORIZONTAL LIGHT */
 /* 0x84BF */ 0xFFFF ,
 /* 0x84C0 */ 0xFFFF ,
 /* 0x84C1 */ 0xFFFF ,
 /* 0x84C2 */ 0xFFFF ,
 /* 0x84C3 */ 0xFFFF ,
 /* 0x84C4 */ 0xFFFF ,
 /* 0x84C5 */ 0xFFFF ,
 /* 0x84C6 */ 0xFFFF ,
 /* 0x84C7 */ 0xFFFF ,
 /* 0x84C8 */ 0xFFFF ,
 /* 0x84C9 */ 0xFFFF ,
 /* 0x84CA */ 0xFFFF ,
 /* 0x84CB */ 0xFFFF ,
 /* 0x84CC */ 0xFFFF ,
 /* 0x84CD */ 0xFFFF ,
 /* 0x84CE */ 0xFFFF ,
 /* 0x84CF */ 0xFFFF ,
 /* 0x84D0 */ 0xFFFF ,
 /* 0x84D1 */ 0xFFFF ,
 /* 0x84D2 */ 0xFFFF ,
 /* 0x84D3 */ 0xFFFF ,
 /* 0x84D4 */ 0xFFFF ,
 /* 0x84D5 */ 0xFFFF ,
 /* 0x84D6 */ 0xFFFF ,
 /* 0x84D7 */ 0xFFFF ,
 /* 0x84D8 */ 0xFFFF ,
 /* 0x84D9 */ 0xFFFF ,
 /* 0x84DA */ 0xFFFF ,
 /* 0x84DB */ 0xFFFF ,
 /* 0x84DC */ 0xFFFF ,
 /* 0x84DD */ 0xFFFF ,
 /* 0x84DE */ 0xFFFF ,
 /* 0x84DF */ 0xFFFF ,
 /* 0x84E0 */ 0xFFFF ,
 /* 0x84E1 */ 0xFFFF ,
 /* 0x84E2 */ 0xFFFF ,
 /* 0x84E3 */ 0xFFFF ,
 /* 0x84E4 */ 0xFFFF ,
 /* 0x84E5 */ 0xFFFF ,
 /* 0x84E6 */ 0xFFFF ,
 /* 0x84E7 */ 0xFFFF ,
 /* 0x84E8 */ 0xFFFF ,
 /* 0x84E9 */ 0xFFFF ,
 /* 0x84EA */ 0xFFFF ,
 /* 0x84EB */ 0xFFFF ,
 /* 0x84EC */ 0xFFFF ,
 /* 0x84ED */ 0xFFFF ,
 /* 0x84EE */ 0xFFFF ,
 /* 0x84EF */ 0xFFFF ,
 /* 0x84F0 */ 0xFFFF ,
 /* 0x84F1 */ 0xFFFF ,
 /* 0x84F2 */ 0xFFFF ,
 /* 0x84F3 */ 0xFFFF ,
 /* 0x84F4 */ 0xFFFF ,
 /* 0x84F5 */ 0xFFFF ,
 /* 0x84F6 */ 0xFFFF ,
 /* 0x84F7 */ 0xFFFF ,
 /* 0x84F8 */ 0xFFFF ,
 /* 0x84F9 */ 0xFFFF ,
 /* 0x84FA */ 0xFFFF ,
 /* 0x84FB */ 0xFFFF ,
 /* 0x84FC */ 0xFFFF 
