<!--
  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at

      http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
-->
<!-- Need a better picture, removed for now
#### [Next Hadoop Wave][revolution]

[![Next Hadoop Wave](images/carousel/revolution.png)][revolution]

Trafodion brings enterprise-class operational workloads to Hadoop! You can now run all of your data workloads on a single platform based on Hadoop.
-->

#### [Hadoop-Scale with SQL Access][scale]

[![Hadoop Scale](images/carousel/scale.png)][scale]

Running out of room with your current SQL solution? Starting a new operational application? Trafodion allows you to work in SQL at Hadoop-scale levels.


#### [Fully Integrated with HBase and Hive][stack]

[![Trafodion Stack](images/carousel/stack.png)][stack]

Trafodion provides SQL access to structured, semi-structured, and unstructured data allowing you to run operational, historical, and analytical workloads on a single platform.


[revolution]: http://trafodion.apache.org
[scale]: http://trafodion.apache.org
[stack]: index.html

---

## News


<table><tr><td>
  <p><h5>The Apache Trafodion team is happy to announce the first Apache release &#8212; version 1.3.0-incubating!</h5></p>
  <p><strong>How to get started with Apache Trafodion:</strong>
     <ul>
       <li><a href="http://trafodion.incubator.apache.org/documentation.html">Release Documentation</a></li>
       <li><a href="http://trafodion.incubator.apache.org/release-notes-1-3-0.html">Release Notes</a></li>
       <li><a href="https://trafodion.incubator.apache.org/download.html">Download</a></li>
       <li><a href="https://github.com/apache/incubator-trafodion">git Site</a></li>
       <li><a href="http://trafodion.incubator.apache.org/contributing-redirect.html">Build Instructions</a></li>
     </ul>
   </p>
   <p><h5>The Trafodion team thanks all our contributors and mentors who made the release possible!</h5></p>

</td></tr></table>

<center><h1>Contributing Companies</h1></center>

---

<!-- Carousel with logos -->

#### Join Our Community

![Slide 1](images/logo-carousel/slide-1.png)

Code, test, present, document, web sites, and many other ways to contribute.

#### Add Your Logo Here

![Slide 2](images/logo-carousel/slide-2.png)

Already a contributor? We need permission to add your company's logo here. 

---

## About

Apache Trafodion is a webscale SQL-on-Hadoop solution enabling transactional or operational workloads on Hadoop. 

The name &quot;Trafodion&quot; (the Welsh word for transactions, pronounced &quot;Tra-vod-eee-on&quot;) was chosen specifically to emphasize the differentiation that Trafodion provides in closing a critical gap in the Hadoop ecosystem. 

Trafodion builds on the scalability, elasticity, and flexibility of Hadoop. Trafodion extends Hadoop to provide guaranteed transactional integrity, enabling new kinds of big data applications to run on Hadoop. 

---

## Key Features

* Full-functioned ANSI SQL language support
* JDBC/ODBC connectivity for Linux/Windows clients
* Distributed ACID transaction protection across multiple statements, tables and rows
* Performance improvements for OLTP workloads with compile-time and run-time optimizations
* Support for large data sets using a parallel-aware query optimizer


## Key Benefits

* Reuse existing SQL skills and improve developer productivity
* Distributed ACID transactions guarantee data consistency across multiple rows and tables
* Interoperability with existing tools and applications
* Hadoop and Linux distribution neutral
* Easy to add to your existing Hadoop infrastructure

---

<table>
  <tr>
    <td width="33%" valign="top">
      <center>
        <h2>Understand</h2>
        <img src="images/logos/understand.png" width="108" height="108"/>
        <h4>What makes Trafodion unique</h4>
        <div class="customHr">.</div>
      </center>
      <ul>
        <li><a href="architecture-overview.html">Architecture</a></li>
        <li><a href="documentation.html">Documentation</a></li>
        <li><a href="faq.html">FAQ</a></li>
      </ul>
    </td>
    <td width="33%" valign="top">
      <center>
        <h2>Use</h2>
        <img src="images/logos/use.png" width="108" height="108"/>
        <h4>Download and try Trafodion</h4>
        <div class="customHr">.</div>
      </center>
      <ul>
        <li><a href="download.html">Download</a></li>
        <li><a href="quickstart.html">Quick Start</a></li>
        <li><a href="release-notes.html">Release Notes</a></li>
      </ul>
    </td>
    <td width="33%" valign="top">
      <center>
        <h2>Community</h2>
        <img src="images/logos/community.png" width="108" height="108"/>
        <h4>Be part of Trafodion</h4>
        <div class="customHr">.</div>
      </center>
      <ul>
        <li><a href="contributing-redirect.html">Contribute</a></li>
        <li><a href="mail-lists.html">Discuss</a></li>
        <li><a href="https://cwiki.apache.org/confluence/display/TRAFODION/Apache+Trafodion+Home">Wiki</a></li>
      </ul>
    </td>
  </tr>
</table>
